//
//  HumanPlayer.swift
//  
//
//  Created by Adam BONAFOS on 21/01/2025.
//

import Foundation
public class HumanPlayer : Player {
    // Propriété CLI de type closure
    private var CLI: ((String) -> String)?

    // Initialisation avec la closure CLI
    public init(rules: Rules, color: Token, name: String, CLI: @escaping (String) -> String) {
        self.CLI = CLI
        super.init(rules: rules, color: color, name: name)
    }

    public override func play(board: Board) -> Move {
        // Demande la colonne à l'utilisateur
        let columnInput = CLI!("Entrez le numéro de la colonne : ")
        guard let column = Int(columnInput) else {
            fatalError("Entrée invalide pour la colonne.")
        }
        // Demande la ligne à l'utilisateur
        let rowInput = CLI!("Entrez le numéro de la ligne : ")
        guard let row = Int(rowInput) else {
            fatalError("Entrée invalide pour la ligne.")
        }
        return Move(row: row, column: column)
    }
}
